// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.21.3
// source: proto/notification.proto

package notification

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// NotificationClient is the client API for Notification service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type NotificationClient interface {
	SendMail(ctx context.Context, in *SendMailReq, opts ...grpc.CallOption) (*NotificationRes, error)
	SendSMS(ctx context.Context, in *SendSMSReq, opts ...grpc.CallOption) (*NotificationRes, error)
	SendWhatsapp(ctx context.Context, in *SendWhatsappReq, opts ...grpc.CallOption) (*NotificationRes, error)
	SendTele(ctx context.Context, in *SendTeleReq, opts ...grpc.CallOption) (*NotificationRes, error)
	SendSlack(ctx context.Context, in *SendSlackReq, opts ...grpc.CallOption) (*NotificationRes, error)
}

type notificationClient struct {
	cc grpc.ClientConnInterface
}

func NewNotificationClient(cc grpc.ClientConnInterface) NotificationClient {
	return &notificationClient{cc}
}

func (c *notificationClient) SendMail(ctx context.Context, in *SendMailReq, opts ...grpc.CallOption) (*NotificationRes, error) {
	out := new(NotificationRes)
	err := c.cc.Invoke(ctx, "/notification.Notification/SendMail", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *notificationClient) SendSMS(ctx context.Context, in *SendSMSReq, opts ...grpc.CallOption) (*NotificationRes, error) {
	out := new(NotificationRes)
	err := c.cc.Invoke(ctx, "/notification.Notification/SendSMS", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *notificationClient) SendWhatsapp(ctx context.Context, in *SendWhatsappReq, opts ...grpc.CallOption) (*NotificationRes, error) {
	out := new(NotificationRes)
	err := c.cc.Invoke(ctx, "/notification.Notification/SendWhatsapp", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *notificationClient) SendTele(ctx context.Context, in *SendTeleReq, opts ...grpc.CallOption) (*NotificationRes, error) {
	out := new(NotificationRes)
	err := c.cc.Invoke(ctx, "/notification.Notification/SendTele", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *notificationClient) SendSlack(ctx context.Context, in *SendSlackReq, opts ...grpc.CallOption) (*NotificationRes, error) {
	out := new(NotificationRes)
	err := c.cc.Invoke(ctx, "/notification.Notification/SendSlack", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// NotificationServer is the server API for Notification service.
// All implementations must embed UnimplementedNotificationServer
// for forward compatibility
type NotificationServer interface {
	SendMail(context.Context, *SendMailReq) (*NotificationRes, error)
	SendSMS(context.Context, *SendSMSReq) (*NotificationRes, error)
	SendWhatsapp(context.Context, *SendWhatsappReq) (*NotificationRes, error)
	SendTele(context.Context, *SendTeleReq) (*NotificationRes, error)
	SendSlack(context.Context, *SendSlackReq) (*NotificationRes, error)
}

// UnimplementedNotificationServer must be embedded to have forward compatible implementations.
type UnimplementedNotificationServer struct {
}

func (UnimplementedNotificationServer) SendMail(context.Context, *SendMailReq) (*NotificationRes, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SendMail not implemented")
}
func (UnimplementedNotificationServer) SendSMS(context.Context, *SendSMSReq) (*NotificationRes, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SendSMS not implemented")
}
func (UnimplementedNotificationServer) SendWhatsapp(context.Context, *SendWhatsappReq) (*NotificationRes, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SendWhatsapp not implemented")
}
func (UnimplementedNotificationServer) SendTele(context.Context, *SendTeleReq) (*NotificationRes, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SendTele not implemented")
}
func (UnimplementedNotificationServer) SendSlack(context.Context, *SendSlackReq) (*NotificationRes, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SendSlack not implemented")
}
func (UnimplementedNotificationServer) mustEmbedUnimplementedNotificationServer() {}

// UnsafeNotificationServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to NotificationServer will
// result in compilation errors.
type UnsafeNotificationServer interface {
	mustEmbedUnimplementedNotificationServer()
}

func RegisterNotificationServer(s grpc.ServiceRegistrar, srv NotificationServer) {
	s.RegisterService(&Notification_ServiceDesc, srv)
}

func _Notification_SendMail_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SendMailReq)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(NotificationServer).SendMail(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/notification.Notification/SendMail",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(NotificationServer).SendMail(ctx, req.(*SendMailReq))
	}
	return interceptor(ctx, in, info, handler)
}

func _Notification_SendSMS_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SendSMSReq)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(NotificationServer).SendSMS(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/notification.Notification/SendSMS",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(NotificationServer).SendSMS(ctx, req.(*SendSMSReq))
	}
	return interceptor(ctx, in, info, handler)
}

func _Notification_SendWhatsapp_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SendWhatsappReq)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(NotificationServer).SendWhatsapp(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/notification.Notification/SendWhatsapp",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(NotificationServer).SendWhatsapp(ctx, req.(*SendWhatsappReq))
	}
	return interceptor(ctx, in, info, handler)
}

func _Notification_SendTele_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SendTeleReq)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(NotificationServer).SendTele(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/notification.Notification/SendTele",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(NotificationServer).SendTele(ctx, req.(*SendTeleReq))
	}
	return interceptor(ctx, in, info, handler)
}

func _Notification_SendSlack_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SendSlackReq)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(NotificationServer).SendSlack(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/notification.Notification/SendSlack",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(NotificationServer).SendSlack(ctx, req.(*SendSlackReq))
	}
	return interceptor(ctx, in, info, handler)
}

// Notification_ServiceDesc is the grpc.ServiceDesc for Notification service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Notification_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "notification.Notification",
	HandlerType: (*NotificationServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "SendMail",
			Handler:    _Notification_SendMail_Handler,
		},
		{
			MethodName: "SendSMS",
			Handler:    _Notification_SendSMS_Handler,
		},
		{
			MethodName: "SendWhatsapp",
			Handler:    _Notification_SendWhatsapp_Handler,
		},
		{
			MethodName: "SendTele",
			Handler:    _Notification_SendTele_Handler,
		},
		{
			MethodName: "SendSlack",
			Handler:    _Notification_SendSlack_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "proto/notification.proto",
}
